import datetime as dt

from sangreal_calendar import step_trade_dt
from uqer import DataAPI

from hbfactor.datasource.sdk import CLIENT


def get_factor(factor_list, sid='', trade_dt=None):
    """[获取因子列表]
    
    Arguments:
        factor_list {[itrable or str]} -- [factor list]
    
    Keyword Arguments:
        sid {str} -- [stock list] (default: {''})
        trade_dt {[type]} -- [description] (default: {None})
    
    Returns:
        [pd.DataFrame] -- [stocks * factors]
    """

    if trade_dt is None:
        trade_dt = step_trade_dt(dt.date.today(), -1)
    df = DataAPI.MktStockFactorsOneDayProGet(
        tradeDate=trade_dt,
        secID=sid,
        field=['secID'] + factor_list,
        pandas="1")
    df.rename(columns={'secID': 'sid'}, inplace=True)
    df.set_index('sid', inplace=True)
    df.columns = [f.lower() for f in df.columns]
    return df
